/// Copyright (c) 2010 Ruben Penalva. All rights reserved.
/// Redistribution and use in source and binary forms, with or without modification, 
/// are permitted provided that the following conditions are met:
///    1. Redistributions of source code must retain the above copyright notice, this 
///    list of conditions and the following disclaimer.
///    2. Redistributions in binary form must reproduce the above copyright notice,
///    this list of conditions and the following disclaimer in the documentation and/or
///    other materials provided with the distribution.
///    3. The name of the author may not be used to endorse or promote products derived
///    from this software without specific prior written permission.
///
/// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
/// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
/// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, 
/// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
/// TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
/// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
/// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#include "OpenglProgram.h"

#include "OpenglException.h"
#include "OpenglLastError.h"

using namespace TestFrameWork;

OpenglProgram::OpenglProgram(const std::vector<ShaderFileDesc>& shaders)
{
	CreateShaders(shaders);

	CreateProgram();
}

OpenglProgram::~OpenglProgram(void)
{
	glDeleteProgram(m_id);
}

GLuint OpenglProgram::GetOpenglId(void) const
{
	return m_id;
}

void OpenglProgram::SetParameter(const std::string& name, float value)
{
	GLint parameterLocation = glGetUniformLocation(m_id, name.c_str());
	TestFrameWork::OnGLErrorThrowException();
	if (parameterLocation < 0)
	{
		throw Exception();
	}

	glUseProgram(m_id);
	TestFrameWork::OnGLErrorThrowException();

	glUniform1f(parameterLocation, value);
	TestFrameWork::OnGLErrorThrowException();
}

void OpenglProgram::SetParameter(const std::string& name, const Vector3& vector)
{
	GLint parameterLocation = glGetUniformLocation(m_id, name.c_str());
	TestFrameWork::OnGLErrorThrowException();
	if (parameterLocation < 0)
	{
		throw Exception();
	}

	glUseProgram(m_id);
	TestFrameWork::OnGLErrorThrowException();

	glUniform3f(parameterLocation, vector.m_x, vector.m_y, vector.m_z);
	TestFrameWork::OnGLErrorThrowException();
}

void OpenglProgram::SetParameter(const std::string& name, const Matrix4x4& matrix)
{
	GLint parameterLocation = glGetUniformLocation(m_id, name.c_str());
	TestFrameWork::OnGLErrorThrowException();
	if (parameterLocation < 0)
	{
		throw Exception();
	}

	glUseProgram(m_id);
	TestFrameWork::OnGLErrorThrowException();

	glUniformMatrix4fv(parameterLocation, 1, GL_TRUE, matrix.GetData());    
	TestFrameWork::OnGLErrorThrowException();
}

void OpenglProgram::SetParameter(const std::string& name, int value)
{
	GLint parameterLocation = glGetUniformLocation(m_id, name.c_str());
	TestFrameWork::OnGLErrorThrowException();
	if (parameterLocation < 0)
	{
		throw Exception();
	}

	glUseProgram(m_id);
	TestFrameWork::OnGLErrorThrowException();

	glUniform1i(parameterLocation, value);
	TestFrameWork::OnGLErrorThrowException();
}

void OpenglProgram::SetTextureUnit(const std::string& name, int unit)
{  
	GLint parameterLocation = glGetUniformLocation(m_id, name.c_str());
	TestFrameWork::OnGLErrorThrowException();
	if (parameterLocation < 0)
	{
		throw Exception();
	}

	glUseProgram(m_id);
	TestFrameWork::OnGLErrorThrowException();

	glUniform1i(parameterLocation, unit);
	TestFrameWork::OnGLErrorThrowException();
}

void OpenglProgram::CreateShaders(const std::vector<ShaderFileDesc>& shaders)
{
	size_t shadersCount = shaders.size();

	for (size_t i = 0; i < shadersCount; ++i)
	{
		OpenglShaderPtr shader(new OpenglShader(shaders[i].m_fileName, shaders[i].m_stage));
		m_shaders.push_back(shader);
	}
}

void OpenglProgram::CreateProgram(void)
{
	m_id = glCreateProgram();
	TestFrameWork::OnGLErrorThrowException();
	if (!m_id)
	{
		throw Exception();
	}

	size_t shadersCount = m_shaders.size();
	for (size_t i = 0; i < shadersCount; ++i)
	{
		glAttachShader(m_id, m_shaders[i]->GetOpenglId());
		TestFrameWork::OnGLErrorThrowException();
	}

	glLinkProgram(m_id);
	TestFrameWork::OnGLErrorThrowException();
}